
//#ifdef USE_ENCRYPTION

#include "EncryptString.h"

EncryptString::EncryptString (void) {
   fromUTF8 = false;
}
EncryptString::~EncryptString (void) {}

void EncryptString::UTF8toExtendedASCII (bool val) {
   fromUTF8 = val;
}

////////////////////////

String EncryptString::ShiftEncrypt (String msg, uint8_t val) {
   int8_t offs = val, stp = -1;


   msg = utf8ascii (msg);
   unsigned int msglen = msg.length();
   unsigned int i;
   //   Serial.printf ("ShiftEncrypt: ASCII LEN: %d\n", msglen);
   String out = "";
   for (i = 0; i < msglen; i++) {
      //            Serial.printf ("ENCRYPT: [%d] Offset; %d\n", i, offs);
      out += (char) (msg[i] + offs);

      //      Serial.printf ("ENCRYPT: [%d] - INPUT: [%c] dec: %d    OUTPUT: [%c] dec: %d    Offset: %d\n", i, msg[i], (uint8_t)msg[i], (msg[i] - offs), (uint8_t) (msg[i] - offs), offs);

      //      if (offs < 0) offs = val;
      if (val > 0) {
         offs += stp;
         if (offs <= 0)
            stp = 1;
         else if (offs >= val)
            stp = -1;
      }
   }

   return out;
}

String EncryptString::ShiftDecrypt (String msg, uint8_t val) {
   int8_t offs = val, stp = -1;
   unsigned int msglen = msg.length();
   unsigned int i;
   //   Serial.printf ("ShiftDecrypt: ASCII LEN: %d\n", msglen);
   String out = "";
   for (i = 0; i < msglen; i++) {
      //            Serial.printf ("DECRYPT: [%d] Offset: %d\n", i, offs);
      /////////out += (char) (msg[i] - offs);
      out += UTF8_from_ISO8859 ((char) (msg[i] - offs));

      //      Serial.printf ("DECRYPT: [%d] - INPUT: [%c] dec: %d    OUTPUT: [%c] dec: %d    Offset: %d\n", i, msg[i], (uint8_t)msg[i], (msg[i] - offs), (uint8_t) (msg[i] - offs), offs);

      //      if (offs < 0) offs = val;
      if (val > 0) {
         offs += stp;
         if (offs <= 0)
            stp = 1;  //offs = val;
         else if (offs >= val)
            stp = -1;
      }
   }

   return out;
}

// ****** UTF8-Decoder: convert UTF8-string to extended ASCII *******

static uint8_t cPrev;  // Last character buffer

// Convert a single Character from UTF8 to Extended ASCII according to ISO 8859-1,
// also called ISO Latin-1. Codes 128-159 contain the Microsoft Windows Latin-1
// extended characters:
// - codes 0..127 are identical in ASCII and UTF-8
// - codes 160..191 in ISO-8859-1 and Windows-1252 are two-byte characters in UTF-8
//                 + 0xC2 then second byte identical to the extended ASCII code.
// - codes 192..255 in ISO-8859-1 and Windows-1252 are two-byte characters in UTF-8
//                 + 0xC3 then second byte differs only in the first two bits to extended ASCII code.
// - codes 128..159 in Windows-1252 are different, but usually only the €-symbol will be needed from this range.
//                 + The euro symbol is 0x80 in Windows-1252, 0xa4 in ISO-8859-15, and 0xe2 0x82 0xac in UTF-8.
//
// Modified from original code at http://playground.arduino.cc/Main/Utf8ascii
// Extended ASCII encoding should match the characters at http://www.ascii-code.com/
//
// Return "0" if a byte has to be ignored.
uint8_t EncryptString::utf8ascii (uint8_t ascii) {
   uint8_t c = '\0';

   //   PRINTX ("\nutf8Ascii 0x", ascii);

   if (ascii < 0x7F) { // Standard ASCII-set 0..0x7F, no conversion
      cPrev = '\0';
      c = ascii;
   } else {
      switch (cPrev) { // Conversion depending on preceding UTF8-character
         case 0xC2: c = ascii;  break;
         case 0xC3: c = ascii | 0xC0;  break;
         //  case 0x82: if (ascii == 0xAC) c = 0x80; break;// € Euro symbol special case (mapped to 0x80 on Windows 1252)
         case 0x82:
            if (ascii == 0xAC) c = 0xA4; // € Euro symbol special case (mapped to 0xA4 on ISO8859-15)
            break;

         case 0xC5: // Changed to match ISO8859-15
            if (ISO_DECODER_TYPE == (char*)"ISO8859-15") {
               switch (ascii) {
                  case 0xA0: c = 0xA6;  break;  // Š
                  case 0xA1: c = 0xA8;  break;  // š
                  case 0xBD: c = 0xB4;  break;  // Ž
                  case 0xBE: c = 0xB8;  break;  // ž
                  case 0x92: c = 0xBC;  break;  // Œ
                  case 0x93: c = 0xBD;  break;  // œ
                  case 0xB8: c = 0xBE;  break;  // Ÿ
               }
            }
            break;

            // default:  
              // Unhandled ///  
      }
      cPrev = ascii;   // Save last char
   }

   return (c);
}

// Convert char array from UTF8 to Extended ASCII (ASCII is shorter!)
char* EncryptString::utf8ascii (char* s) {
   int k = 0;
   char c;
   for (unsigned int i = 0; i < strlen (s); i++) {
      c = utf8ascii (s[i]);
      if (c != 0)  s[k++] = c;
   }
   s[k] = 0;
   return s;
}

// Convert String object from UTF8 to Extended ASCII
String EncryptString::utf8ascii (String s) {
   String r = "";
   char c;
   for (unsigned int i = 0; i < s.length(); i++) {
      c = utf8ascii (s.charAt (i));
      if (c != 0) r += c;
   }
   return r;
}

//#endif  // End of #ifdef USE_ENCRYPTION
////////////////////////////////////
